/*********************************************
PWM + QEI + IC eXgvO
**********************************************/
#include <p33fj128mc802.h>
#include <math.h>

// foCXRtBM[V
_FBS(0xFFFF);
_FSS(0xFFFF);
_FGS(0xFFFF);
_FOSCSEL(FNOSC_FRCPLL);			// vC}IV[^ɓUq𗘗pCPLL𗘗pD
_FOSC(OSCIOFNC_ON);             // OSC2 (10ԃs) ʏI/Os@ƂD OFFƂƃNbN10ԃso͂D
_FWDT(FWDTEN_OFF);				// EHb`hbN^C}  SWDTEN rbgɂI/It@_SWDTEN = 0 ŃEHb`hbO^C}It
_FPOR(FPWRT_PWR128);            // Power-on Reset Timer 128ms
_FICD(JTAGEN_OFF & ICS_PGD1);	// JTAGItCICSPɂfobOp[qPGD1i4ԃsjɐݒ

// PWMgݒ
const unsigned int 		PWMPeriod = 1000;                       // 40MHz/20kHz/2 (OpgPWM[h)  PWMg@20KHz

//^C}ݒ
const unsigned int      tsamp2 = 0x0;                           // Timer2 }b`ŃC^vg
unsigned int            tmr2_matchflag = 0;                     // Timer2 }b`tO

// GR[_萔
unsigned int            IC_count_to_wdet = 47520;
                        // 61.7rps(3700rpm)ɂ CvbgLv` Edgecount = 40MHz/T2_PS_1_256/61.7rps/GR[_pX/IC_Every_Rise_Fall_Edge
                        // = 40000000/256/61.7/12/2 = 105.6
                        // wdet = IC_count_to_wdet/Edgecount = 47520/105.6 = 450@[^̒ixɂwdet̒lƂȂlIC_count_to_wdet

//DMA
#define         NUMSAMP 	 1                                  // ADϊI̓]f[^ (dwߒlCdol)
unsigned int    ADCBuffer[NUMSAMP] __attribute__((space(dma))); //ADϊʂDMAɂ]w

void DAConv(unsigned int a, signed int b);
void init_DMA1(unsigned int a);
void init_SPI(void);
void init_ADC(void);
void init_PWM(void);
void init_QEI(void);
void init_IC(void);
void init_Timer2(void);

//^C}2I[o[t[荞ݏ֐
void __attribute__((interrupt, no_auto_psv)) _T2Interrupt(void) 
{	
   	_LATA2 = 1; 					// 9ԃs I
    
	tmr2_matchflag = 1;
    
   	_LATA2 = 0; 					// 9ԃs It
	_T2IF = 0;						// 荞݃tONA
}

// CvbgLv`荞ݏ֐@]olvZ
void __attribute__((interrupt, no_auto_psv)) _IC1Interrupt(void) 
{
    unsigned int	IC_count;       // ICɂ^C}2̃JEgl
    signed int      wdet;           //]ol
   	
    _LATA3 = 1; 					// 10ԃsI@IC1InterruptNj^p
    
        TMR2 = 0;                   // timer2̃Zbg
    
        // CvbgLv`̃NbNǂݏo
            IC_count = IC1BUF + 1;

        //]olvZ
			wdet = (signed int)(IC_count_to_wdet/IC_count); 
		
        // Timer2}b``FbN
            if(tmr2_matchflag == 1)
            {
                wdet = 0;
                tmr2_matchflag = 0;
            }

        //[^]o@PF]COFt]
            if(_UPDN == 0)
            {
                wdet = -wdet;
            }
            
	// ]olj^
        DAConv((wdet + 512)<<2, 0xF000);      // `lBI
            
	_LATA3 = 0;                             // 10ԃsIt@
	_IC1IF = 0;                             // 荞݃tONA
}

// DMA1荞ݏ֐(PWMɂgK  ADϊ  DMAf[^]I荞݁j
// f[eB䌈
void __attribute__((interrupt, no_auto_psv)) _DMA1Interrupt(void)
{
	unsigned int	Vol_com;                    // PWM dwߒl
    
   	_LATB5 = 1;                                 // 14ԃsI

	//[^]o@PF]COFt]
        _LATA4 = _UPDN;
    
    Vol_com = ADCBuffer[0];                     // ]wߒnǂݏo

	// ]wߒlj^
        DAConv(Vol_com << 2, 0x7000);           // `lAI

	// f[eBݒ	
        P1DC1 = Vol_com << 1;
        
    _LATB5 = 0; 								// 14ԃs It
	_DMA1IF = 0;								//荞݃tONA
}

//C֐
int main(void)
{
    //PLLݒ
        _PLLPRE   =  0;     // N1 =  2
        _PLLDIV   = 42;     //  M = 44
        _PLLPOST  =  0;     // N2 = 2
                        // FOSC = FRC * M / (N1 * N2), FCY = Fosc / 2
                        // FOSC = 7.37 MHz * 44 / (2 * 2) = 81MHz,  FCY = 40.5MHz
        _SWDTEN = 0;                    //EHb`hbO^C}It
        while(OSCCONbits.LOCK !=1 );   	// PLLbN҂

	// I/O |[gݒ
        TRISA = 	0x0001;                 // RA0 , RA1 - 5 o̓|[gݒ
        TRISB = 	0b0000000111000000;		// RB6-8 ̓|[gݒ
	
	// SPIp|[gݒ
        _RP11R =  8;			//RP11  SCK (01000) Ɋ蓖
        _RP10R =  7;			//RP10  SDO (00111)Ɋ蓖
    
   	// QEIp|[gݒ
        _QEA1R = 7;             // QEA1R @RP7 Ɋ蓖
        _QEB1R = 6;             // QEB1R @RP6 Ɋ蓖

    //ICp|[gݒ
        _IC1R = 8;              // IC1R  RP8 Ɋ蓖		

        // ӃW[ݒ
	init_DMA1(NUMSAMP);     // DMAݒ	
	init_SPI();             // SPIݒ
	init_ADC();             // ADCݒ
    init_PWM();             // MCPWM ݒ
    init_QEI();            	// QEIݒ
    init_IC();              // ICݒ
    init_Timer2();          // timer2ݒ
    
	//[v
	while(1){}
}


