/*********************************************
PWM + QEI + IC eXgvOi12rbgxj
**********************************************/
#include <p33fj128mc802.h>
#include <math.h>

// foCXRtBM[V
_FBS(0xFFFF);
_FSS(0xFFFF);
_FGS(0xFFFF);
_FOSCSEL(FNOSC_FRCPLL);			// vC}IV[^ɓUq𗘗pCPLL𗘗pD
_FOSC(OSCIOFNC_ON);             // OSC2 (10ԃs) ʏI/Os@ƂD OFFƂƃNbN10ԃso͂D
_FWDT(FWDTEN_OFF);				// EHb`hbN^C}  SWDTEN rbgɂI/It@_SWDTEN = 0 ŃEHb`hbO^C}It
_FPOR(FPWRT_PWR128);            // Power-on Reset Timer 128ms
_FICD(JTAGEN_OFF & ICS_PGD1);	// JTAGItCICSPɂfobOp[qPGD1i4ԃsjɐݒ

// PWMgݒ
const unsigned int 		PWMPeriod = 1000;                       // 40MHz/20kHz/2 (OpgPWM[h)  PWMg@20KHz

//^C}ݒ
const unsigned int      tsamp2 = 0x0;                           // Timer2 }b`ŃC^vg
unsigned long           num_tmr2_match = 0;                     // Timer2 }b`

// GR[_萔
unsigned long           IC_count_to_wdet = 6081100;
                        // 61.7rps(3700rpm)ɂ CvbgLv` Edgecount = 40MHz/T2_PS_1_8/61.7rps/GR[_pX/IC_Every_Rise_Fall_Edge
                        // = 40000000*60/8/3700/12/2 = 3378.4
                        // wdet = Edgecount_to_wdet/Edgecount = 6081100/3378.4 = 1800

//DMA
#define         NUMSAMP 	 1                                  // ADϊI̓]f[^ (dwߒlCdol)
unsigned int    ADCBuffer[NUMSAMP] __attribute__((space(dma))); //ADϊʂDMAɂ]w

void DAConv(unsigned int a, signed int b);
void init_DMA1(unsigned int a);
void init_SPI(void);
void init_ADC(void);
void init_PWM(void);
void init_QEI(void);
void init_IC(void);
void init_Timer2(void);

//^C}2}b`荞ݏ֐
void __attribute__((interrupt, no_auto_psv)) _T2Interrupt(void) 
{	
   	_LATA2 = 1; 					// 9ԃs I
    
	num_tmr2_match += 1;            // }b`
    
   	_LATA2 = 0; 					// 9ԃs It
	_T2IF = 0;						// 荞݃tONA
}

// CvbgLv`荞ݏ֐@]olvZ
void __attribute__((interrupt, no_auto_psv)) _IC1Interrupt(void) 
{
    signed int      wdet;           // ]ol
    unsigned long   IC_count;       // GR[_GbWԂ̃NbN
   	
    _LATA3 = 1; 					// 10ԃsI@IC1InterruptNj^p

    TMR2 = 0;                       // TMR2Zbg
    
        // CvbgLv`̃NbNǂݏoƏ}b`񐔕̃NbNZ
            IC_count = (unsigned long)(IC1BUF + 1) + (num_tmr2_match << 16); 
                    
        //]olvZ
			wdet = (signed int)(IC_count_to_wdet/IC_count); 
		
            num_tmr2_match = 0;             // }b`񐔃Zbg

        //[^]o@PF]COFt]
            if(_UPDN == 0)
            {
                wdet = -wdet;
            }
            
	// ]olj^
        DAConv(wdet + 2048, 0xF000);      // `lBI
            
	_LATA3 = 0;                             // 10ԃsIt@
	_IC1IF = 0;                             // 荞݃tONA
}

// DMA1荞ݏ֐(PWMɂgK  ADϊ  DMAf[^]I荞݁j
// f[eB䌈
void __attribute__((interrupt, no_auto_psv)) _DMA1Interrupt(void)
{
	unsigned int	Vol_com;                    // PWM dwߒl
    
   	_LATB5 = 1;                                 // 14ԃsI

	//[^]o@PF]COFt]
        _LATA4 = _UPDN;
    
    Vol_com = ADCBuffer[0];                     // ]wߒlǂݏo

	// ]wߒlj^
        DAConv(Vol_com, 0x7000);                // `lAI

	// f[eBݒ	
        P1DC1 = Vol_com >> 1;                   // 12bitwߒl@@11bitɕϊ@(PWMperiod (10 + 1)bit)
        
    _LATB5 = 0; 								// 14ԃs It
	_DMA1IF = 0;								//荞݃tONA
}

//C֐
int main(void)
{
    //PLLݒ
        _PLLPRE   =  0;     // N1 =  2
        _PLLDIV   = 42;     //  M = 44
        _PLLPOST  =  0;     // N2 = 2
                        // FOSC = FRC * M / (N1 * N2), FCY = Fosc / 2
                        // FOSC = 7.37 MHz * 44 / (2 * 2) = 81MHz,  FCY = 40.5MHz
        _SWDTEN = 0;                    //EHb`hbO^C}It
        while(OSCCONbits.LOCK !=1 );   	// PLLbN҂

	// I/O |[gݒ
        TRISA = 	0x0001;                 // RA0 , RA1 - 5 o̓|[gݒ
        TRISB = 	0b0000000111000000;		// RB6-8 ̓|[gݒ
	
	// SPIp|[gݒ
        _RP11R =  8;			//RP11  SCK (01000) Ɋ蓖
        _RP10R =  7;			//RP10  SDO (00111)Ɋ蓖
    
   	// QEIp|[gݒ
        _QEA1R = 7;             // QEA1R @RP7 Ɋ蓖
        _QEB1R = 6;             // QEB1R @RP6 Ɋ蓖

    //ICp|[gݒ
        _IC1R = 8;              // IC1R  RP8 Ɋ蓖		

        // ӃW[ݒ
	init_DMA1(NUMSAMP);     // DMAݒ	
	init_SPI();             // SPIݒ
	init_ADC();             // ADCݒ
    init_PWM();             // MCPWM ݒ
    init_QEI();            	// QEIݒ
    init_IC();              // ICݒ
    init_Timer2();          // timer2ݒ
    
	//[v
	while(1){}
}


